#ifndef _HATPTREE_H_
#define _HATPTREE_H_

#include <vector>

#include <hatp_msgs/TreeNode.h>
#include <hatp_msgs/Plan.h>

#include <libhatp/hatpTaskList.h>

class hatpPlan;

class hatpTree{
private:
	hatpPlan& plan;
	unsigned int root;
	
	unsigned int depth;

public:
// 	hatpTree(hatpPlan& plan);
	hatpTree(hatpPlan& plan, const hatp_msgs::Plan& msg);
	
	unsigned int getRootID() const;
	hatpTaskPtr getRootNode() const;

	unsigned int getTreeDepth() const; //Actually give the index of the maximum depth
// 	std::vector<std::pair<unsigned int, unsigned int> > getTreeCausalLinks() const;
// 	std::vector<std::pair<unsigned int, unsigned int> > getTreeHierarchicalLinks() const;

	std::string toString() const;
};

#endif //_HATPTREE_H_
